#include "cthugha.h"
#include "information.h"
#include "options.h"
#include "display.h"
#include "sound.h"
#include "action.h"
#include "translate.h"
#include "keys.h"
#include "interface.h"
#include "waves.h"

#include <unistd.h>


//
// Info interface
//
class InterfaceInfo : public InterfaceMain {
public:
    InterfaceInfo() : InterfaceMain() {}

    void display() {
	// Christopher L. Platt  (croutons%crunchy.uucp@dartmouth.edu)
	// also did some of this
	char str[128];
	int line = 0;

	display_print("Info", line, 'l', TEXT_COLOR_HIGHLIGHT); 
	line ++;
	display_print("----------------------------------------", line, 'l', TEXT_COLOR_NORMAL); 
	line ++; 

	sprintf(str, "Wave (w,W)     : %s (%s) - %d", 
		wave.currentName(), wave.currentDesc(), 
		int(waveScale) );
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "Flame (f,F,g)  : %s (%s)", flame.currentName(), flame.currentDesc());
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "Display (d,D)  : %s (%s)", screen.currentName(),	screen.currentDesc());
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "Palette (p,P)  : %s (%s)", palette.currentName(), palette.currentDesc());
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "Translate (t,T): %s (%s)", translate.currentName(), translate.currentDesc());
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "Next PCX (x,,X): %s (%s)", pcx.currentName(), pcx.currentDesc());
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "Object (j,J)   : %s", object.currentName());
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "Table (b,B)    : %d", int(table));
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "Massage (m,M)  : %d", int(massage));
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;

	sprintf(str, "%s%s%s",
		int(lock)	? "LOCKED " : "",
		int(fft)	? "FFT "    : "",
		int(flashlight) ? "Flash "  : "");
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;
		
	sprintf(str, "Frames/s: %2.2f", fps);
	display_print(str, line, 'l', TEXT_COLOR_NORMAL); 
	line ++;
    }    
};

Interface * interfaceInfo = new InterfaceInfo;





