#include "cthugha.h"
#include "interface.h"
#include "keys.h"
#include "sound.h"
#include "display.h"
#include "disp-sys.h"
#include "options.h"
#include "action.h"

#include <unistd.h>

//
// main interface (no text)
//
InterfaceMain::InterfaceMain() : Interface(NULL, 0), silenceMsg(NULL) {
}

int InterfaceMain::do_key(int key) {
    switch(key) {
    case 'q': case 'Q': case CK_ESC: 
	setInterface(interfaceCredits);		
	return 0;

    case 'f':		flame.changeNext();		return 0;
    case 'F':		flame.changePrev();		return 0;
    case 'g': case 'G':	flameGeneral.changeRandom();	return 0;

    case 'w':		wave.changeNext();		return 0;
    case 'W':		waveScale.changeNext();		return 0;
    case 'j':		object.changeNext();		return 0;
    case 'J':		object.changePrev();		return 0;

    case 'd':		screen.changeNext();		return 0;
    case 'D':		screen.changePrev();		return 0;

    case 't':		translate.changeNext();		return 0;
    case 'T':		translate.changePrev();		return 0;

    case 'm':		massage.changeNext();		return 0;
    case 'M':		massage.changePrev();		return 0;
	
    case 'h': case 'H':	mirrorHoriz.changeNext();	return 0;
    case 'v': case 'V':	mirrorVert.changeNext();	return 0;
	
    case 's': case 'S':	flashlight.changeNext();	return 0;
    case 'e': case 'E':	fft.changeNext();		return 0;
	
    case 'p':		palette.changeNext();		return 0;
    case 'P':		palette.changePrev();		return 0;
    case 'b':		table.changeNext();		return 0;
    case 'B':		table.changePrev();		return 0;
	
    case 'r': case 'R':	rgb.changeNext();;			return 0;
	
	
    case 'l': case 'L': lock.changeNext();		return 0;
		
    case 'x': case 'X':				/* show pcx-picture */
	if ( display_use_pcx) { 
	    pcx();				// show it
	    
	    display();
	    display_sync_sys();
//	    sleep(1);

	    if(key == 'x')
		pcx.changeNext();
	    else
		pcx.changePrev();
	} else {
	    errors.addMessage("PCX is disabled");
	}
	return 0;
	
    case 'a': case 'A':
	write_ini();
	return 0;
	
    case 'n': case 'N':			/* send request to server */
	soundDevice->update();
	return 0;
	
    case CK_PRINT: case '#':		/* real print screen */
	save_display();
	return 0;
	
    case CK_BACK:			/* change back */
	Option::restore();
	return 0;

    case CK_SHIFT(0):    case CK_SHIFT(1):
    case CK_SHIFT(2):    case CK_SHIFT(3):
    case CK_SHIFT(4):    case CK_SHIFT(5):
    case CK_SHIFT(6):    case CK_SHIFT(7):
    case CK_SHIFT(8):    case CK_SHIFT(9):	// store hot 
	Option::save(key - CK_SHIFT(0));
	return 0;
    case '0':    case '1':
    case '2':    case '3':
    case '4':    case '5':
    case '6':    case '7':
    case '8':    case '9':
	Option::restore(key - '0');
	return 0;
	
    default:				/* change everything */
	key = Interface::do_key(key);
	if( key != 0) 
	    general_change();
	return key;
    }
}

void InterfaceMain::display() {
    if( (gettime() - silenceTime) > display_text_time) {
	silenceMsg = NULL;
	return;
    }

    if(silenceMsg == NULL)
	return;
    
    display_print(silenceMsg, silenceLine, 'c', TEXT_COLOR_NORMAL);
}

void InterfaceMain::msg(char * msg) {
    silenceTime = gettime();
    silenceMsg = msg;
    silenceLine = rand() % (text_size.y - 5);
}


Interface * interfaceMain = new InterfaceMain();

