#include "cthugha.h"
#include "imath.h"
#include "Option.h"

OptionAllow::OptionAllow(const char * name, int (*f)(), int v = CHANGE_RANDOM, int hist = 0) :
    Option(name, hist), fkt(f) {

    switch(v) {
    case CHANGE_RANDOM:
    case CHANGE_NEXT: case CHANGE_PREV:
	value = OptionAllow::off;
	changeTo(v);
	break;
    default:
	value = v;
    }
}


// does not change "allowedness"
void OptionAllow::changeTo(int to) {
    if(value == disabled)
	return;

    switch(to) {
    case CHANGE_RANDOM:
	value = rand() % 2;
	break;
    case CHANGE_NEXT: case CHANGE_PREV:
	value = value ? off : on;
	break;
    default:
	value = to ? on : off;
    }
}

void OptionAllow::changeTo(const char * to) {

    if ( ! strncasecmp("yes", to, 3) )
	value = 1;
    else if ( ! strncasecmp("on", to, 2) )
	value = 1;
    else if ( ! strncasecmp("1", to, 1) )
	value = 1;
    else if ( ! strncasecmp("no", to, 2) )
	value = 0;
    else if ( ! strncasecmp("off", to, 3) )
	value = 0;
    else if ( ! strncasecmp("0", to, 1) )
	value = 0;
    else if ( ! strncasecmp("disable", to, 7) )
	value = 2;
    else {
	printfe("Illegal allowance-value `%s' for %s.\n", to, name);
    }

}


// changes btw. disallwod, off (allowed) and on
void OptionAllow::changeBy(int by) {
    value = mod(value + by, 3);
}



const char* OptionAllow::text() const {
    switch(value) {
    case on:
	return " on";
    case off:
	return "off";
    case disabled:
	return "disabled";
    }
    return "";
}
