#include "cthugha.h"
#include "Option.h"
#include "imath.h"

//
// Integer Options
//
void OptionInt::changeTo(int to) {

    if(maxValue > 0)		// they all have minValue = 0
	switch(to) {
	case CHANGE_RANDOM:
	    value =  rand() % maxValue;
	    break;
	case CHANGE_NEXT:
	    value = (value + 1) % maxValue;
	    break;
	case CHANGE_PREV:
	    value = (value + maxValue - 1) % maxValue;
	    break;
	default:
	    if (to < minValue)		
		value = minValue;
	    else if (to >= maxValue)	
		value = maxValue-1;
	    else 
		value = to;
	}
    else 
	switch(to) {
	case CHANGE_RANDOM:
	    value = rand();
	    break;
	case CHANGE_NEXT:
	    value = (value + 1);
	    break;
	case CHANGE_PREV:
	    value = max(value - 1, 0);
	    break;
	default:
	    value = to;
	    if (to < minValue)	
		value = minValue;
	}
}

void OptionInt::changeBy(int by) {
   value += by;
   
   if(value < 0)
       value = 0;
   if( (maxValue > 0) && (value >= maxValue) )
       value = maxValue-1;
}


//
// change to String
// str can be: an integer: time in 1/100 of a sec
//             a double with "sec" afterwards: time in seconds
//
void OptionTime::changeTo(const char * str) {
 
    if( strstr(str, "sec") != NULL) {
	double d;
	if( sscanf(str, "%lfsec", &d) == 0) {
	    printfe("Not a time value `%s' for %s.\n", str, name);
	    return;
	}
	value = int(d * 100 + 0.5);
    } else {
	char * pos;
	int tvalue = strtol(str, &pos, 0);
	if (str == pos ) {			// not a number
	    printfe("Not a number `%s' for %s.\n", str, name);
	    return;
	}
	value = tvalue;
    }
    if(value < 0)
	value = 0;
}

