#include "cthugha.h"
#include "action.h"
#include "sound.h"
#include "display.h"
#include "translate.h"
#include "information.h"
#include "cd_player.h"
#include "interface.h"
#include "server.h"
#include "waves.h"
#include "cth_buffer.h"

OptionOnOff lock("lock", 0);			/* change automatically */
OptionOnOff change_little("little", 0);		/* only change one options */

#define MAX_SILENCE_STRINGS 256

static char * silence_strings[MAX_SILENCE_STRINGS] = {/* Display when no sound */
/*   1234567890123456789012345678901234567890	*/
    "Where is the music?",	/* 0 */
    "JOLT !",			/* 1 */	
    "Turn The Music On",	/* 2 */	
    "Lets Party!!!",		/* 3 */	
    "Pink Floyd Rules",		/* 4 */	
    "Sounds of Silence ?",	/* 5 */	
    "The Torps",		/* 6 */	
    "Study Mathematics",	/* 7 */	
    "Visit Linz",		/* 8 */	
    "Press ? for help",		/* 9 */	
    "Number 5 is ALIVE!!",	/* 10 */	
    "Spooky Mulder.....",	/* 11 */	
    "Wheres Cthugha 6.0?",	/* 12 */	
    "Subliminal Ads",		/* 13 */	
    "Read a book",		/* 14 */	
    "Get a life...",		/* 15 */	
    "SMILE!",			/* 16 */	
    "Cthugha-L",		/* 17 */	
    "Don't Panic!",		/* 18 */	
    "@fortune"			/* 19 */
};
static int nr_silence_strings = 20;



/*
 * change everything 
 */
int general_change() {
    if(int(change_little) ) {
	Option::changeOne();
    } else {
	Option::changeAll();
    }

    return 0;
}

/*
 * The Main-display-Funktion
 */
double fps = 0;
int display_sound() {
    int change;
    int i;

    /* compute frames/second, of at least 3 frames or 0.1 second */
    i = gettime() - display_start;
    if( (i > 10) && (display_frames > 2) )
	fps = 100.0 * double(display_frames) / double(i);

    /* accept requests from clients */
    if( int(server) )
	server_accept();

    /* set border to black */
    memset(active_buffer+BUFF_SIZE,   0, 3*BUFF_WIDTH);
    memset(active_buffer-3*BUFF_WIDTH,0, 3*BUFF_WIDTH);

    done_translate = 0;
    
    flame();				/* flame (primary transformation) */
    translate();			/* secondard transformation */
    get_sound();			/* Get the next sound into memory */
    change = sound_noise_check();
    if( int(server))			/* send to clients */
	broadcast_sound();
    flashlight();
    fft();
    massage_audio();
    wave();				// draw the sound
	
    if ( (change == 1) && !int(lock)) {		/* want change and not locked */
	general_change();
	if( (display_use_pcx) && (pcx_count -- <= 0) ) {
	    show_pcx(rand() % 2, rand() % 3);
	    pcx_count = rand() % 5;
	    pcx.changeTo(CHANGE_RANDOM);
	}
    }

    if ( change == -1 ) {		/* silence */
	int print_nr = rand() % nr_silence_strings;

	if ( silence_strings[ print_nr][0] != '@' ) {
	    /* traditional string */
	    ((InterfaceMain*)interfaceMain)->msg( silence_strings[ print_nr]);
	} else {
	    /* print fortune */
	    FILE * msgPipe;

	    if ( (msgPipe = popen("fortune","r")) == NULL) {
		((InterfaceMain*)interfaceMain)->msg("Can not open fortune pipe");
	    } else {
		static char str[4096];
		str[ fread( str, 1, 4096, msgPipe) ] = '\0';
		((InterfaceMain*)interfaceMain)->msg(str);
		pclose(msgPipe);
	    }
	}
    }

    smooth_setpalette();		/* smooth pal. to next */
    display();				/* bring the active_buffer to screen */

    cd_check();				/* check for complete rotation of CD */
    return 0;
}



void load_quiet_strings(char * fname) {

    FILE * file;
    char * s;
	
    if ( (fname == NULL) || (*fname == '\0'))
	return;
	
    if( (file = fopen(fname, "r")) == NULL) {
	printfee("Can't open quiet strings file `%s'.", fname);
	return;
    }

    nr_silence_strings = 0;		
    do {
	/* read a line */
	silence_strings[nr_silence_strings] = new char[256];
	s = fgets(silence_strings[nr_silence_strings], 255, file);	
	if ( s != NULL)
	    nr_silence_strings ++;
    } while ( (nr_silence_strings < MAX_SILENCE_STRINGS) && (s != NULL) );

    /* check if file was empty */
    if ( nr_silence_strings == 0) {
	printfv(0,"silence strings file `%s' was empty.\n", fname);
	nr_silence_strings = 1;
	strcpy( silence_strings[0], "Where is the music?");
    }
}










