/*
    CTHUGHA-L 							cthugha.h
*/

#ifndef __CTHUGHA_H__
#define __CTHUGHA_H__

#include <config.h>

/* check if CDROM header file is available, if not disable the cdrom */
#if !defined(HAVE_LINUX_CDROM_H) && !defined(HAVE_SYS_CDROM_H)
# undef WITH_CDROM
# define WITH_CDROM 0
#endif

/* check if soundcard header file is available, if not disable DSP and Mixer */
#if !defined(HAVE_LINUX_SOUNDCARD_H) && !defined(HAVE_SYS_SOUNDCARD_H)
# undef WITH_DSP
# undef WITH_MIXER
# define WITH_DSP 0
# define WITH_MIXER 0
#endif

#include <stdlib.h>
#include <stdio.h>

/* this is suggested by autoconf */
#if STDC_HEADERS
# include <string.h>
#else
# ifndef HAVE_STRCHR
#  define strchr index
#  define strrchr rindex
# endif
char *strchr (), *strrchr ();
# ifndef HAVE_MEMCPY
#  define memcpy(d, s, n) bcopy ((s), (d), (n))
#  define memmove(d, s, n) bcopy ((s), (d), (n))
# endif
#endif

#include <limits.h>
#ifndef PATH_MAX
# define PATH_MAX 4096
#endif


/*
 * variables
 */
extern int cthugha_close;			/* cthugha is closing now */
extern int cthugha_pause;			/* cthugha is suspending (^Z) now */

char * cthugha_mode_text();			/* returns "svga", "xwin", ... */

int cth_init(int * argc, char * argv[]);
int cth_main();

int printfv(int lvl, const char * fmt, ...);	// print verbose message
int printfee(const char * fmt, ...);		// print error msg with errno 
int printfe(const char * fmt, ...);		// print error msg (no errno)


int gettime();

typedef struct {
    int x, y;
} xy;


#endif







