/*
 * some important parts written by:
 *  Mark Vojkovich (mvojkovi@ucsd.edu) 
 */

#include "cthugha.h"
#include "display.h"
#include "disp-sys.h"
#include "imath.h"

int display_text_time = 300;
int display_text_color[][3] = {
    {0, 255, 255},		/* normal */
    {255, 0, 0},		/* error */
    {255, 255, 255}		/* highlight */
};
int display_text_colors = 3;

int display_text_on_screen = 0;	

xy text_size = {0,0};

const int fontSize = 8;

//
// display some text on the screen
//
void display_print(const char * text, double y, int justify, int color) {

    if(text_size.x == 0) {
	text_size.x = disp_size.x / fontSize;
	text_size.y = disp_size.y / fontSize;
    }

    const char * lineStart = text;
    const char * lineEnd;
    do {
	lineEnd = strchr(lineStart, '\n');
	int len = lineEnd ? lineEnd - lineStart : strlen(lineStart);
	int x;
	
	if(len == 0)
	    return;
	
	switch(justify) {
	case 'l': 
	    x = 0;
	    break;
	case 'c':
	    x = max( fontSize * (text_size.x - len) / 2, 0);
	    break;
	case 'r':
	    x = max( fontSize * (text_size.x - len), 0);
	    break;
	default:
	    printfe("unknown justification (internal error).\n");
	    x = 0;
	}
	
	display_print_string_sys(x, (y >= 0) ? int(y*fontSize) : int(fontSize*(text_size.y + y)), 
				 lineStart, color, len);
				 
	lineStart = lineEnd + 1;	// go to next line
	y += 1;
    } while(lineEnd);
}


