#include "cthugha.h"
#include "sound.h"
#include "cd_player.h"
#include "interface.h"
#include "server.h"

#include <unistd.h>

#ifdef HAVE_NCURSES_H
# include <ncurses.h>
#else
#  if HAVE_NCURSES_NCURSES_H
#    include <ncurses/ncurses.h>
#  else
#    if HAVE_CURSES_H
#      include <curses.h>
#    else
#      if HAVE_NCURSES_CURSES_H
#        include <ncurses/curses.h>
#      endif
#    endif
#  endif
#endif

extern int notServer;

char * cthugha_mode_text() {
    return "serv";
}
/*
 * Get a "line" of sound from the soundcard 
 */
int serv_sound_read() {

    if( nr_clients == 0) {		/* if no client connected, */
	exit_sound();			/* we don't need the sound device */
	return 0;
    }

    init_sound();			/* make sure we have the sound dev */

    soundDevice->read();

    return 0;
}

int cth_init(int * /*argc*/, char ** /*argv*/) {

    server.changeTo(1);
    notServer = 0;

    return 0;
}

int cth_main() {
    exit_sound();

    interfaceToggle = 0;
    setInterface(interfaceServer);

    do {
	serv_sound_read();

	broadcast_sound();
	server_accept();

	display_text_erase();

	currentInterface->display();		// print the text of the current interface
	errors.display();			// and the error messages

	display_text_refresh();

	currentInterface->run();
	if(currentInterface == interfaceMain)
	    return 0;

	cd_check();

	if(int(srv_wait_time))
	    usleep(int(srv_wait_time)*1000);

    } while(cthugha_close == 0);

    return 0;
}
