// -*-c++-*-
//
//    CTHUGHA-L							translate.h
//

#ifndef __TRANSLATE_H__
#define __TRANSLATE_H__

#include "Option.h"

class TranslateEntry : public OptionListEntry {
public:
    int * trans;

    TranslateEntry(const char * name, const char * desc) :
	OptionListEntry(name, desc), trans(NULL) {}
    virtual ~TranslateEntry() {
	delete [] trans;
	trans = NULL;
    }

    int operator()();				// do a translation

    friend OptionListEntry * read_trans(FILE *, const char *, const char *);
    friend OptionListEntry * read_cmdtrans(FILE *, const char *, const char *);
};


int init_translate();

extern OptionOnOff use_translates;		/* allow translations */
extern OptionOnOff trans_stretch;		/* allow stretching */
extern char translate_first[256];		/* first translation */

extern int done_translate;			/* trans. already done for this iteration */

#endif
